diff --git a/binaries/data/mods/public/simulation/components/ProductionQueue.js b/binaries/data/mods/public/simulation/components/ProductionQueue.js
index 6c72202..447b0ff 100644
--- a/binaries/data/mods/public/simulation/components/ProductionQueue.js
+++ b/binaries/data/mods/public/simulation/components/ProductionQueue.js
@@ -3,6 +3,8 @@ const MAX_QUEUE_SIZE = 16;
 
 function ProductionQueue() {}
 
+ProductionQueue.prototype.ResourceSchema = Resources.BuildSchema("nonNegativeDecimal", [ "time" ]);
+
 ProductionQueue.prototype.Schema =
 	"<a:help>Allows the building to train new units and research technologies</a:help>" +
 	"<a:example>" +
@@ -31,13 +33,7 @@ ProductionQueue.prototype.Schema =
 		"</element>" +
 	"</optional>" +
 	"<element name='TechCostMultiplier' a:help='Multiplier to modify ressources cost and research time of technologies searched in this building.'>" +
-		"<interleave>" +
-			"<element name='food'><ref name='nonNegativeDecimal'/></element>" +
-			"<element name='wood'><ref name='nonNegativeDecimal'/></element>" +
-			"<element name='stone'><ref name='nonNegativeDecimal'/></element>" +
-			"<element name='metal'><ref name='nonNegativeDecimal'/></element>" +
-			"<element name='time'><ref name='nonNegativeDecimal'/></element>" +
-		"</interleave>" +
+		ProductionQueue.prototype.ResourceSchema +
 	"</element>";
 
 ProductionQueue.prototype.Init = function()
@@ -260,7 +256,8 @@ ProductionQueue.prototype.AddBatch = function(templateName, type, count, metadat
 	// TODO: there should probably be a limit on the number of queued batches
 	// TODO: there should be a way for the GUI to determine whether it's going
 	// to be possible to add a batch (based on resource costs and length limits)
-	var cmpPlayer = QueryOwnerInterface(this.entity);
+	let cmpPlayer = QueryOwnerInterface(this.entity);
+	let resCodes = Resources.GetCodes();
 
 	if (this.queue.length < MAX_QUEUE_SIZE)
 	{
@@ -293,10 +290,13 @@ ProductionQueue.prototype.AddBatch = function(templateName, type, count, metadat
 			var buildTime = ApplyValueModificationsToTemplate("Cost/BuildTime", +template.Cost.BuildTime, cmpPlayer.GetPlayerID(), template);
 			var time = timeMult * buildTime;
 
-			for (var r in template.Cost.Resources)
+			for (let res in template.Cost.Resources)
 			{
-				costs[r] = ApplyValueModificationsToTemplate("Cost/Resources/"+r, +template.Cost.Resources[r], cmpPlayer.GetPlayerID(), template);
-				totalCosts[r] = Math.floor(count * costs[r]);
+				let cost = +template.Cost.Resources[res];
+				if (resCodes.indexOf(res) < 0)
+					continue;
+				costs[res] = ApplyValueModificationsToTemplate("Cost/Resources/"+res, cost, cmpPlayer.GetPlayerID(), template);
+				totalCosts[res] = Math.floor(count * costs[res]);
 			}
 
 			var population = ApplyValueModificationsToTemplate("Cost/Population",  +template.Cost.Population, cmpPlayer.GetPlayerID(), template);
@@ -341,9 +341,13 @@ ProductionQueue.prototype.AddBatch = function(templateName, type, count, metadat
 			let techCostMultiplier = this.GetTechCostMultiplier();
 			let time =  techCostMultiplier.time * template.researchTime * cmpPlayer.GetCheatTimeMultiplier();
 
-			var cost = {};
+			let cost = {};
 			for (let res in template.cost)
-				cost[res] = Math.floor(techCostMultiplier[res] * template.cost[res]);
+			{
+				if (resCodes.indexOf(res) < 0)
+					continue;
+				cost[res] = Math.floor((techCostMultiplier[res] ? techCostMultiplier[res] : 1) * template.cost[res]);
+			}
 
 			// TrySubtractResources should report error to player (they ran out of resources)
 			if (!cmpPlayer.TrySubtractResources(cost))
@@ -361,7 +365,7 @@ ProductionQueue.prototype.AddBatch = function(templateName, type, count, metadat
 				"player": cmpPlayer.GetPlayerID(),
 				"count": 1,
 				"technologyTemplate": templateName,
-				"resources": deepcopy(template.cost), // need to copy to avoid serialization problems
+				"resources": cost,
 				"productionStarted": false,
 				"timeTotal": time*1000,
 				"timeRemaining": time*1000,
@@ -433,8 +437,10 @@ ProductionQueue.prototype.RemoveBatch = function(id)
 		// Refund the resource cost for this batch
 		var totalCosts = {};
 		var cmpStatisticsTracker = QueryPlayerIDInterface(item.player, IID_StatisticsTracker);
-		for each (var r in ["food", "wood", "stone", "metal"])
+		for (let r of Resources.GetCodes())
 		{
+			if (!item.resources[r])
+				continue;
 			totalCosts[r] = Math.floor(item.count * item.resources[r]);
 			if (cmpStatisticsTracker)
 				cmpStatisticsTracker.IncreaseResourceUsedCounter(r, -totalCosts[r]);
diff --git a/binaries/data/mods/public/simulation/components/ResourceDropsite.js b/binaries/data/mods/public/simulation/components/ResourceDropsite.js
index 819807c..a14ddaf 100644
--- a/binaries/data/mods/public/simulation/components/ResourceDropsite.js
+++ b/binaries/data/mods/public/simulation/components/ResourceDropsite.js
@@ -1,15 +1,12 @@
 function ResourceDropsite() {}
 
+ResourceDropsite.prototype.ResourceChoiceSchema = Resources.BuildChoicesSchema();
+
 ResourceDropsite.prototype.Schema =
 	"<element name='Types'>" +
 		"<list>" +
 			"<zeroOrMore>" +
-				"<choice>" +
-					"<value>food</value>" +
-					"<value>wood</value>" +
-					"<value>stone</value>" +
-					"<value>metal</value>" +
-				"</choice>" +
+				ResourceDropsite.prototype.ResourceChoiceSchema +
 			"</zeroOrMore>" +
 		"</list>" +
 	"</element>" +
@@ -24,12 +21,14 @@ ResourceDropsite.prototype.Init = function()
 };
 
 /**
- * Returns the list of resource types accepted by this dropsite.
+ * Returns the list of resource types accepted by this dropsite,
+ * as defined by it being referred to in the template and the resource being enabled.
  */
 ResourceDropsite.prototype.GetTypes = function()
 {
 	let types = ApplyValueModificationsToEntity("ResourceDropsite/Types", this.template.Types, this.entity);
-	return types ? types.split(/\s+/) : [];
+	let resources = Resources.GetCodes();
+	return types.split(/\s+/).filter(type => resources.indexOf(type.toLowerCase()) > -1);
 };
 
 /**
diff --git a/binaries/data/mods/public/simulation/components/ResourceGatherer.js b/binaries/data/mods/public/simulation/components/ResourceGatherer.js
index acd5fbd..52f0b44 100644
--- a/binaries/data/mods/public/simulation/components/ResourceGatherer.js
+++ b/binaries/data/mods/public/simulation/components/ResourceGatherer.js
@@ -1,5 +1,8 @@
 function ResourceGatherer() {}
 
+ResourceGatherer.prototype.ResourcesSchema = Resources.BuildSchema("positiveDecimal", [ "treasure" ], true);
+ResourceGatherer.prototype.CapacitiesSchema = Resources.BuildSchema("positiveDecimal");
+
 ResourceGatherer.prototype.Schema =
 	"<a:help>Lets the unit gather resources from entities that have the ResourceSupply component.</a:help>" +
 	"<a:example>" +
@@ -25,35 +28,10 @@ ResourceGatherer.prototype.Schema =
 		"<ref name='positiveDecimal'/>" +
 	"</element>" +
 	"<element name='Rates' a:help='Per-resource-type gather rate multipliers. If a resource type is not specified then it cannot be gathered by this unit'>" +
-		"<interleave>" +
-			"<optional><element name='food' a:help='Food gather rate (may be overridden by \"food.*\" subtypes)'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='wood' a:help='Wood gather rate'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='stone' a:help='Stone gather rate'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='metal' a:help='Metal gather rate'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='treasure' a:help='Treasure gather rate (only presense on value makes sense, size is only used to determine the delay before gathering, so it should be set to 1)'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='food.fish' a:help='Fish gather rate (overrides \"food\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='food.fruit' a:help='Fruit gather rate (overrides \"food\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='food.grain' a:help='Grain gather rate (overrides \"food\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='food.meat' a:help='Meat gather rate (overrides \"food\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='food.milk' a:help='Milk gather rate (overrides \"food\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='wood.tree' a:help='Tree gather rate (overrides \"wood\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='wood.ruins' a:help='Tree gather rate (overrides \"wood\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='stone.rock' a:help='Rock gather rate (overrides \"stone\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='stone.ruins' a:help='Rock gather rate (overrides \"stone\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='metal.ore' a:help='Ore gather rate (overrides \"metal\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='treasure.food' a:help='Food treasure gather rate (overrides \"treasure\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='treasure.wood' a:help='Wood treasure gather rate (overrides \"treasure\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='treasure.stone' a:help='Stone treasure gather rate (overrides \"treasure\")'><ref name='positiveDecimal'/></element></optional>" +
-			"<optional><element name='treasure.metal' a:help='Metal treasure gather rate (overrides \"treasure\")'><ref name='positiveDecimal'/></element></optional>" +
-		"</interleave>" +
+		ResourceGatherer.prototype.ResourcesSchema +
 	"</element>" +
 	"<element name='Capacities' a:help='Per-resource-type maximum carrying capacity'>" +
-		"<interleave>" +
-			"<element name='food' a:help='Food capacity'><ref name='positiveDecimal'/></element>" +
-			"<element name='wood' a:help='Wood capacity'><ref name='positiveDecimal'/></element>" +
-			"<element name='stone' a:help='Stone capacity'><ref name='positiveDecimal'/></element>" +
-			"<element name='metal' a:help='Metal capacity'><ref name='positiveDecimal'/></element>" +
-		"</interleave>" +
+		ResourceGatherer.prototype.CapacitiesSchema +
 	"</element>";
 
 ResourceGatherer.prototype.Init = function()
@@ -137,6 +115,12 @@ ResourceGatherer.prototype.RecalculateGatherRatesAndCapacities = function()
 	this.rates = {};
 	for (let r in this.template.Rates)
 	{
+		let type = r.split(".");
+		let res = Resources.GetResource(type[0]);
+
+		if (!res && type[0] !== "treasure" || (type.length > 1 && res.subtypes.indexOf(type[1]) < 0))
+			continue;
+
 		let rate = ApplyValueModificationsToEntity("ResourceGatherer/Rates/" + r, +this.template.Rates[r], this.entity);
 		this.rates[r] = rate * this.baseSpeed;
 	}
@@ -174,7 +158,7 @@ ResourceGatherer.prototype.GetRange = function()
 
 /**
  * Try to gather treasure
- * @return 'true' if treasure is successfully gathered and 'false' in the other case
+ * @return 'true' if treasure is successfully gathered and 'false' if not
  */
 ResourceGatherer.prototype.TryInstantGather = function(target)
 {
diff --git a/binaries/data/mods/public/simulation/components/ResourceSupply.js b/binaries/data/mods/public/simulation/components/ResourceSupply.js
index 04e95da..7cc580b 100644
--- a/binaries/data/mods/public/simulation/components/ResourceSupply.js
+++ b/binaries/data/mods/public/simulation/components/ResourceSupply.js
@@ -1,5 +1,7 @@
 function ResourceSupply() {}
 
+ResourceSupply.prototype.ResourceChoiceSchema = Resources.BuildChoicesSchema(true, true);
+
 ResourceSupply.prototype.Schema =
 	"<a:help>Provides a supply of one particular type of resource.</a:help>" +
 	"<a:example>" +
@@ -12,23 +14,8 @@ ResourceSupply.prototype.Schema =
 	"<element name='Amount' a:help='Amount of resources available from this entity'>" +
 		"<choice><data type='nonNegativeInteger'/><value>Infinity</value></choice>" +
 	"</element>" +
-	"<element name='Type' a:help='Type of resources'>" +
-		"<choice>" +
-			"<value>wood.tree</value>" +
-			"<value>wood.ruins</value>" +
-			"<value>stone.rock</value>" +
-			"<value>stone.ruins</value>" +
-			"<value>metal.ore</value>" +
-			"<value>food.fish</value>" +
-			"<value>food.fruit</value>" +
-			"<value>food.grain</value>" +
-			"<value>food.meat</value>" +
-			"<value>food.milk</value>" +
-			"<value>treasure.wood</value>" +
-			"<value>treasure.stone</value>" +
-			"<value>treasure.metal</value>" +
-			"<value>treasure.food</value>" +
-		"</choice>" +
+	"<element name='Type' a:help='Type and Subtype of resource available from this entity'>" +
+		ResourceSupply.prototype.ResourceChoiceSchema +
 	"</element>" +
 	"<element name='MaxGatherers' a:help='Amount of gatherers who can gather resources from this entity at the same time'>" +
 		"<data type='nonNegativeInteger'/>" +
@@ -45,16 +32,23 @@ ResourceSupply.prototype.Init = function()
 	this.amount = this.GetMaxAmount();
 
 	this.gatherers = [];	// list of IDs for each players
-	var cmpPlayerManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_PlayerManager);	// system component so that's safe.
-	var numPlayers = cmpPlayerManager.GetNumPlayers();
-	for (var i = 0; i <= numPlayers; ++i)	// use "<=" because we want Gaia too.
+	let cmpPlayerManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_PlayerManager);	// system component so that's safe.
+	let numPlayers = cmpPlayerManager.GetNumPlayers();
+	for (let i = 0; i <= numPlayers; ++i)	// use "<=" because we want Gaia too.
 		this.gatherers.push([]);
 
 	this.infinite = !isFinite(+this.template.Amount);
 
-	[this.type,this.subType] = this.template.Type.split('.');
-	this.cachedType = { "generic" : this.type, "specific" : this.subType };
+	[this.type, this.subtype] = this.template.Type.split('.');
+	let resData = Resources.GetResource(this.type);
+	if (this.type === "treasure")
+		resData = { "subtypes": Resources.GetCodes() };
+
+	// Remove entity from gameworld if the resource supplied by this entity is disabled or not valid.
+	if (!resData || resData.subtypes.indexOf(this.subtype) === -1)
+		Engine.DestroyEntity(this.entity);
 
+	this.cachedType = { "generic" : this.type, "specific" : this.subtype };
 };
 
 ResourceSupply.prototype.IsInfinite = function()
diff --git a/binaries/data/mods/public/simulation/components/ResourceTrickle.js b/binaries/data/mods/public/simulation/components/ResourceTrickle.js
index 5c554e7..7bed918 100644
--- a/binaries/data/mods/public/simulation/components/ResourceTrickle.js
+++ b/binaries/data/mods/public/simulation/components/ResourceTrickle.js
@@ -1,30 +1,11 @@
 function ResourceTrickle() {}
 
+ResourceTrickle.prototype.ResourcesSchema = Resources.BuildSchema("nonNegativeDecimal");
+
 ResourceTrickle.prototype.Schema = 
 	"<a:help>Controls the resource trickle ability of the unit.</a:help>" +
 	"<element name='Rates' a:help='Trickle Rates'>" +
-		"<interleave>" +
-			"<optional>" +
-				"<element name='food' a:help='Food given to the player every interval'>" +
-					"<ref name='nonNegativeDecimal'/>" +
-				"</element>" +
-			"</optional>" +
-			"<optional>" +
-				"<element name='wood' a:help='Wood given to the player every interval'>" +
-					"<ref name='nonNegativeDecimal'/>" +
-				"</element>" +
-			"</optional>" +
-			"<optional>" +
-				"<element name='stone' a:help='Stone given to the player every interval'>" +
-					"<ref name='nonNegativeDecimal'/>" +
-				"</element>" +
-			"</optional>" +
-			"<optional>" +
-				"<element name='metal' a:help='Metal given to the player every interval'>" +
-					"<ref name='nonNegativeDecimal'/>" +
-				"</element>" +
-			"</optional>" +
-		"</interleave>" +
+		ResourceTrickle.prototype.ResourcesSchema +
 	"</element>" +
 	"<element name='Interval' a:help='Number of miliseconds must pass for the player to gain the next trickle.'>" +
 		"<ref name='nonNegativeDecimal'/>" +
@@ -45,9 +26,14 @@ ResourceTrickle.prototype.GetTimer = function()
 
 ResourceTrickle.prototype.GetRates = function()
 {
-	var rates = {};
-	for (var resource in this.template.Rates)
+	let rates = {};
+	let resCodes = Resources.GetCodes();
+	for (let resource in this.template.Rates)
+	{
+		if (resCodes.indexOf(resource) < 0)
+			continue;
 		rates[resource] = ApplyValueModificationsToEntity("ResourceTrickle/Rates/"+resource, +this.template.Rates[resource], this.entity);
+	}
 
 	return rates;
 };
@@ -55,13 +41,9 @@ ResourceTrickle.prototype.GetRates = function()
 // Do the actual work here
 ResourceTrickle.prototype.Trickle = function(data, lateness)
 {
-	var cmpPlayer = QueryOwnerInterface(this.entity);
-	if (!cmpPlayer)
-		return;
-
-	var rates = this.GetRates();
-	for (var resource in rates)
-		cmpPlayer.AddResource(resource, rates[resource]);
+	let cmpPlayer = QueryOwnerInterface(this.entity, IID_Player);
+	if (cmpPlayer)
+		cmpPlayer.AddResources(this.GetRates());
 };
 
 Engine.RegisterComponentType(IID_ResourceTrickle, "ResourceTrickle", ResourceTrickle);
diff --git a/binaries/data/mods/public/simulation/components/StatisticsTracker.js b/binaries/data/mods/public/simulation/components/StatisticsTracker.js
index 3bc1f79..482502d 100644
--- a/binaries/data/mods/public/simulation/components/StatisticsTracker.js
+++ b/binaries/data/mods/public/simulation/components/StatisticsTracker.js
@@ -105,30 +105,18 @@ StatisticsTracker.prototype.Init = function()
 	this.buildingsCapturedValue = 0;
 
 	this.resourcesGathered = {
-		"food": 0,
-		"wood": 0,
-		"metal": 0,
-		"stone": 0,
 		"vegetarianFood": 0
 	};
-	this.resourcesUsed = {
-		"food": 0,
-		"wood": 0,
-		"metal": 0,
-		"stone": 0
-	};
-	this.resourcesSold = {
-		"food": 0,
-		"wood": 0,
-		"metal": 0,
-		"stone": 0
-	};
-	this.resourcesBought = {
-		"food": 0,
-		"wood": 0,
-		"metal": 0,
-		"stone": 0
-	};
+	this.resourcesUsed = {};
+	this.resourcesSold = {};
+	this.resourcesBought = {};
+	for (let res of Resources.GetCodes())
+	{
+		this.resourcesGathered[res] = 0;
+		this.resourcesUsed[res] = 0;
+		this.resourcesSold[res] = 0;
+		this.resourcesBought[res] = 0;
+	}
 
 	this.tributesSent = 0;
 	this.tributesReceived = 0;
@@ -347,7 +335,8 @@ StatisticsTracker.prototype.IncreaseResourceGatheredCounter = function(type, amo
  */
 StatisticsTracker.prototype.IncreaseResourceUsedCounter = function(type, amount)
 {
-	this.resourcesUsed[type] += amount;
+	if (typeof this.resourcesUsed[type] === "number")
+		this.resourcesUsed[type] += amount;
 };
 
 StatisticsTracker.prototype.IncreaseTreasuresCollectedCounter = function()
diff --git a/binaries/data/mods/public/simulation/components/Trader.js b/binaries/data/mods/public/simulation/components/Trader.js
index 735778d..771a814 100644
--- a/binaries/data/mods/public/simulation/components/Trader.js
+++ b/binaries/data/mods/public/simulation/components/Trader.js
@@ -4,9 +4,6 @@
 // Additional gain for ships for each garrisoned trader, in percents
 const GARRISONED_TRADER_ADDITION = 20;
 
-// Array of resource names
-const RESOURCES = ["food", "wood", "stone", "metal"];
-
 function Trader() {}
 
 Trader.prototype.Schema =
diff --git a/binaries/data/mods/public/simulation/components/tests/test_GuiInterface.js b/binaries/data/mods/public/simulation/components/tests/test_GuiInterface.js
index 6ae026e..7e7f2d2 100644
--- a/binaries/data/mods/public/simulation/components/tests/test_GuiInterface.js
+++ b/binaries/data/mods/public/simulation/components/tests/test_GuiInterface.js
@@ -33,6 +33,12 @@ Engine.LoadComponentScript("interfaces/Upgrade.js");
 Engine.LoadComponentScript("interfaces/BuildingAI.js");
 Engine.LoadComponentScript("GuiInterface.js");
 
+Resources = {
+	"GetCodes": function() { return [ "food", "metal", "stone", "wood" ] },
+	"GetNames": function() { return { "food": "Food", "metal": "Metal", "stone": "Stone", "wood": "Wood" } },
+	"GetResource": function() { return {}; },
+};
+
 var cmp = ConstructComponent(SYSTEM_ENTITY, "GuiInterface");
 
 
@@ -330,7 +336,22 @@ TS_ASSERT_UNEVAL_EQUALS(cmp.GetSimulationState(), {
 	circularMap: false,
 	timeElapsed: 0,
 	gameType: "conquest",
-	barterPrices: {buy: {food: 150}, sell: {food: 25}}
+	barterPrices: {buy: {food: 150}, sell: {food: 25}},
+	resources: {
+		codes: [ "food", "metal", "stone", "wood" ],
+		names: {
+			"food": "Food",
+			"metal": "Metal",
+			"stone": "Stone",
+			"wood": "Wood",
+		},
+		aiInfluenceGroups: {
+			"food": 0,
+			"metal": 0,
+			"stone": 0,
+			"wood": 0,
+		}
+	},
 });
 
 TS_ASSERT_UNEVAL_EQUALS(cmp.GetExtendedSimulationState(), {
@@ -449,7 +470,22 @@ TS_ASSERT_UNEVAL_EQUALS(cmp.GetExtendedSimulationState(), {
 	circularMap: false,
 	timeElapsed: 0,
 	gameType: "conquest",
-	barterPrices: {buy: {food: 150}, sell: {food: 25}}
+	barterPrices: {buy: {food: 150}, sell: {food: 25}},
+	resources: {
+		codes: [ "food", "metal", "stone", "wood" ],
+		names: {
+			"food": "Food",
+			"metal": "Metal",
+			"stone": "Stone",
+			"wood": "Wood",
+		},
+		aiInfluenceGroups: {
+			"food": 0,
+			"metal": 0,
+			"stone": 0,
+			"wood": 0,
+		}
+	},
 });
 
 
diff --git a/binaries/data/mods/public/simulation/components/tests/test_Player.js b/binaries/data/mods/public/simulation/components/tests/test_Player.js
index 4191a68..7cba52a 100644
--- a/binaries/data/mods/public/simulation/components/tests/test_Player.js
+++ b/binaries/data/mods/public/simulation/components/tests/test_Player.js
@@ -9,6 +9,11 @@ Engine.LoadComponentScript("Timer.js")
 ConstructComponent(SYSTEM_ENTITY, "EndGameManager");
 ConstructComponent(SYSTEM_ENTITY, "Timer");
 
+Resources = {
+	"GetCodes": function() { return [ "food", "metal", "stone", "wood" ] },
+	"GetResource": function() { return {}; },
+};
+
 var cmpPlayer = ConstructComponent(10, "Player");
 
 TS_ASSERT_EQUALS(cmpPlayer.GetPopulationCount(), 0);
diff --git a/binaries/data/mods/public/simulation/helpers/Resources.js b/binaries/data/mods/public/simulation/helpers/Resources.js
new file mode 100644
index 0000000..af6f747
--- /dev/null
+++ b/binaries/data/mods/public/simulation/helpers/Resources.js
@@ -0,0 +1,2 @@
+
+Resources = new Resources();
